﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FlyADBase
{
    /// <summary>
    /// 高级timegrid
    /// </summary>
    public class TimeGridAdvEventArgs : EventArgs
    {
        /// <summary>
        /// 
        /// </summary>
        public TimeGridAdvEventArgs()
        {

        }
        
        /// <summary>
        /// 
        /// </summary>
        public int Marker { get; set; }
        public Misc.DIRECTION Direction { get; set; }
        /// <summary>
        /// 数据
        /// </summary>
        public IEnumerable<TimeGridAdvUnit> Data { get; set; }
    }
    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public delegate void TimeGridAdvEventHandler(object sender, TimeGridAdvEventArgs e);

    /// <summary>
    /// 高级timegrid 每个单元
    /// </summary>
    public class TimeGridAdvUnit
    {
        /// <summary>
        /// 时间
        /// </summary>
        public DateTime dt;

        /// <summary>
        /// ad值
        /// </summary>
        public int ad;

        /// <summary>
        /// 脉冲
        /// </summary>
        public int pos;

        /// <summary>
        /// 脉冲2
        /// </summary>
        public int pos2;


        /// <summary>
        /// 状态
        /// </summary>
        public UInt16 istatus;
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public override string ToString()
        {
            return $"{dt.Ticks} |ad={ad} |p={pos} |p2={pos2} |i={istatus:X2}";
        }
    }


    /// <summary>
    /// 高级timegrid
    /// </summary>
    public class TimeGridAdv2EventArgs : EventArgs
    {
        /// <summary>
        /// 
        /// </summary>
        public TimeGridAdv2EventArgs()
        {

        }

        public DateTime EndTime;
        /// <summary>
        /// 
        /// </summary>
        public int Marker;

        public Misc.DIRECTION Direction;

        public List<int> AdList;

        public List<int> PosList;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public delegate void TimeGridAdv2EventHandler(object sender, TimeGridAdv2EventArgs e);
}
